/****************************************************************************
                             Hyper's CD Catalog
		A multiplatform qt and xml based catalog program

 Author    : Peter Deak (hyperr@freemail.hu)
 License   : GPL
 Copyright : (C) 2003 Peter Deak
****************************************************************************/

#ifndef GUIBASE_CDCAT
#define GUIBASE_CDCAT


#include <qobject.h>
#include <qlistview.h>
#include <qpopupmenu.h>

class Node;
class CdCatMainWidget;


class GuiSlave : public QObject
 {
  Q_OBJECT

 public:
  CdCatMainWidget *mainw;
  Node *standON;
  Node *NodePwd;
  Node *tmpParent;
  
  QPopupMenu *mPopup;

  GuiSlave(CdCatMainWidget *p);
  Node *getNodeFromFullName(Node *root,const QString& newloc);
  int updateListFromNode(Node *pdir = 0);
  int isIdentical(int i);
  int isIdentical(QString q);
  void updateStatusl(Node *n);

 public slots:

  int hotKeys(QKeyEvent *ke);
  int listUpdate    (const QString& newloc);
  int standOn       (QListViewItem *on);
  int doubleClickOn (QListViewItem *on);
  void showListviewContextMenu(QListViewItem *, const QPoint &, int);
  void showTreeContextMenu(QListViewItem *, const QPoint &, int);
   
  int cHcaption(void);

  void panelsOFF(void); /*I do this if the user do something on the database*/
  void panelsON (void);

  /*Mainwinow Buttons*/
  int newEvent    (void);
  int openEvent   (void);
  int saveEvent   (void);
  int saveasEvent (void);
  int closeEvent  (void);
  int deleteEvent (void);
  int addEvent    (void);
  int rescanEvent (void);
  int findEvent   (void);
  int configEvent (void);
  int aboutEvent  (void);
  int helpEvent   (void);
  int insertcEvent(void);
  int renameEvent (void);
  int sizeEvent   (void);
  int importEvent (void);
  int exportEvent (void);
  int renumberEvent(void);

  int sortNuEvent (void);
  int sortNaEvent (void);
  int sortTyEvent (void);
  int sortTiEvent (void);
  
  int openHistoryElementEvent(int id);

};

/**********************************************************************/

class HQListView : public QListView
 {
  Q_OBJECT
  public:
   CdCatMainWidget *mainw;
   HQListView(CdCatMainWidget *mw,QWidget *parent=0,const char *name=0,WFlags f=0);
   void start(void);
   void curr_vis(void);
   void changed(void);

  protected:
   void keyPressEvent(QKeyEvent *ke);
 };
#endif



